structure Ta = 
struct

datatype color = R | B;

fun id x = (fn xa => xa) x;

type 'a eq = {eq : 'a -> 'a -> bool};
fun eq (A_:'a eq) = #eq A_;

datatype ('a, 'b) rbt = Empty |
  Tr of color * ('a, 'b) rbt * 'a * 'b * ('a, 'b) rbt;

datatype ('a, 'b) ta_rule = Rule of 'a * 'b * 'a list;

fun lhs (Rule (q, l, qs)) = q;

fun eqa A_ a b = eq A_ a b;

fun leta s f = f s;

type 'a ord = {less_eq : 'a -> 'a -> bool, less : 'a -> 'a -> bool};
fun less_eq (A_:'a ord) = #less_eq A_;
fun less (A_:'a ord) = #less A_;

fun hd (x :: xs) = x;

fun tl [] = []
  | tl (x :: xs) = xs;

fun suc n = IntInf.+ (n, (1 : IntInf.int));

fun balance (Tr (R, a, w, x, b)) s t (Tr (R, c, y, z, d)) =
  Tr (R, Tr (B, a, w, x, b), s, t, Tr (B, c, y, z, d))
  | balance (Tr (R, Tr (R, a, w, x, b), s, t, c)) y z Empty =
    Tr (R, Tr (B, a, w, x, b), s, t, Tr (B, c, y, z, Empty))
  | balance (Tr (R, Tr (R, a, w, x, b), s, t, c)) y z (Tr (B, va, vb, vc, vd)) =
    Tr (R, Tr (B, a, w, x, b), s, t, Tr (B, c, y, z, Tr (B, va, vb, vc, vd)))
  | balance (Tr (R, Empty, w, x, Tr (R, b, s, t, c))) y z Empty =
    Tr (R, Tr (B, Empty, w, x, b), s, t, Tr (B, c, y, z, Empty))
  | balance (Tr (R, Tr (B, va, vb, vc, vd), w, x, Tr (R, b, s, t, c))) y z Empty
    = Tr (R, Tr (B, Tr (B, va, vb, vc, vd), w, x, b), s, t,
           Tr (B, c, y, z, Empty))
  | balance (Tr (R, Empty, w, x, Tr (R, b, s, t, c))) y z
    (Tr (B, va, vb, vc, vd)) =
    Tr (R, Tr (B, Empty, w, x, b), s, t,
         Tr (B, c, y, z, Tr (B, va, vb, vc, vd)))
  | balance (Tr (R, Tr (B, ve, vf, vg, vh), w, x, Tr (R, b, s, t, c))) y z
    (Tr (B, va, vb, vc, vd)) =
    Tr (R, Tr (B, Tr (B, ve, vf, vg, vh), w, x, b), s, t,
         Tr (B, c, y, z, Tr (B, va, vb, vc, vd)))
  | balance Empty w x (Tr (R, b, s, t, Tr (R, c, y, z, d))) =
    Tr (R, Tr (B, Empty, w, x, b), s, t, Tr (B, c, y, z, d))
  | balance (Tr (B, va, vb, vc, vd)) w x (Tr (R, b, s, t, Tr (R, c, y, z, d))) =
    Tr (R, Tr (B, Tr (B, va, vb, vc, vd), w, x, b), s, t, Tr (B, c, y, z, d))
  | balance Empty w x (Tr (R, Tr (R, b, s, t, c), y, z, Empty)) =
    Tr (R, Tr (B, Empty, w, x, b), s, t, Tr (B, c, y, z, Empty))
  | balance Empty w x (Tr (R, Tr (R, b, s, t, c), y, z, Tr (B, va, vb, vc, vd)))
    = Tr (R, Tr (B, Empty, w, x, b), s, t,
           Tr (B, c, y, z, Tr (B, va, vb, vc, vd)))
  | balance (Tr (B, va, vb, vc, vd)) w x
    (Tr (R, Tr (R, b, s, t, c), y, z, Empty)) =
    Tr (R, Tr (B, Tr (B, va, vb, vc, vd), w, x, b), s, t,
         Tr (B, c, y, z, Empty))
  | balance (Tr (B, va, vb, vc, vd)) w x
    (Tr (R, Tr (R, b, s, t, c), y, z, Tr (B, ve, vf, vg, vh))) =
    Tr (R, Tr (B, Tr (B, va, vb, vc, vd), w, x, b), s, t,
         Tr (B, c, y, z, Tr (B, ve, vf, vg, vh)))
  | balance Empty s t Empty = Tr (B, Empty, s, t, Empty)
  | balance Empty s t (Tr (B, va, vb, vc, vd)) =
    Tr (B, Empty, s, t, Tr (B, va, vb, vc, vd))
  | balance Empty s t (Tr (B, va, vb, vc, Empty)) =
    Tr (B, Empty, s, t, Tr (B, va, vb, vc, Empty))
  | balance Empty s t (Tr (v, Empty, vb, vc, Empty)) =
    Tr (B, Empty, s, t, Tr (v, Empty, vb, vc, Empty))
  | balance Empty s t (Tr (v, Tr (B, ve, vf, vg, vh), vb, vc, Empty)) =
    Tr (B, Empty, s, t, Tr (v, Tr (B, ve, vf, vg, vh), vb, vc, Empty))
  | balance Empty s t (Tr (B, va, vb, vc, Tr (B, vf, vg, vh, vi))) =
    Tr (B, Empty, s, t, Tr (B, va, vb, vc, Tr (B, vf, vg, vh, vi)))
  | balance Empty s t (Tr (v, Empty, vb, vc, Tr (B, vf, vg, vh, vi))) =
    Tr (B, Empty, s, t, Tr (v, Empty, vb, vc, Tr (B, vf, vg, vh, vi)))
  | balance Empty s t
    (Tr (v, Tr (B, ve, vj, vk, vl), vb, vc, Tr (B, vf, vg, vh, vi))) =
    Tr (B, Empty, s, t,
         Tr (v, Tr (B, ve, vj, vk, vl), vb, vc, Tr (B, vf, vg, vh, vi)))
  | balance (Tr (B, va, vb, vc, vd)) s t Empty =
    Tr (B, Tr (B, va, vb, vc, vd), s, t, Empty)
  | balance (Tr (B, va, vb, vc, vd)) s t (Tr (B, ve, vf, vg, vh)) =
    Tr (B, Tr (B, va, vb, vc, vd), s, t, Tr (B, ve, vf, vg, vh))
  | balance (Tr (B, va, vb, vc, vd)) s t (Tr (B, ve, vf, vg, Empty)) =
    Tr (B, Tr (B, va, vb, vc, vd), s, t, Tr (B, ve, vf, vg, Empty))
  | balance (Tr (B, va, vb, vc, vd)) s t (Tr (v, Empty, vf, vg, Empty)) =
    Tr (B, Tr (B, va, vb, vc, vd), s, t, Tr (v, Empty, vf, vg, Empty))
  | balance (Tr (B, va, vb, vc, vd)) s t
    (Tr (v, Tr (B, vi, vj, vk, vl), vf, vg, Empty)) =
    Tr (B, Tr (B, va, vb, vc, vd), s, t,
         Tr (v, Tr (B, vi, vj, vk, vl), vf, vg, Empty))
  | balance (Tr (B, va, vb, vc, vd)) s t
    (Tr (B, ve, vf, vg, Tr (B, vj, vk, vl, vm))) =
    Tr (B, Tr (B, va, vb, vc, vd), s, t,
         Tr (B, ve, vf, vg, Tr (B, vj, vk, vl, vm)))
  | balance (Tr (B, va, vb, vc, vd)) s t
    (Tr (v, Empty, vf, vg, Tr (B, vj, vk, vl, vm))) =
    Tr (B, Tr (B, va, vb, vc, vd), s, t,
         Tr (v, Empty, vf, vg, Tr (B, vj, vk, vl, vm)))
  | balance (Tr (B, va, vb, vc, vd)) s t
    (Tr (v, Tr (B, vi, vn, vo, vp), vf, vg, Tr (B, vj, vk, vl, vm))) =
    Tr (B, Tr (B, va, vb, vc, vd), s, t,
         Tr (v, Tr (B, vi, vn, vo, vp), vf, vg, Tr (B, vj, vk, vl, vm)))
  | balance Empty s t Empty = Tr (B, Empty, s, t, Empty)
  | balance (Tr (B, va, vb, vc, vd)) s t Empty =
    Tr (B, Tr (B, va, vb, vc, vd), s, t, Empty)
  | balance (Tr (B, Empty, vb, vc, vd)) s t Empty =
    Tr (B, Tr (B, Empty, vb, vc, vd), s, t, Empty)
  | balance (Tr (v, Empty, vb, vc, Empty)) s t Empty =
    Tr (B, Tr (v, Empty, vb, vc, Empty), s, t, Empty)
  | balance (Tr (v, Empty, vb, vc, Tr (B, ve, vf, vg, vh))) s t Empty =
    Tr (B, Tr (v, Empty, vb, vc, Tr (B, ve, vf, vg, vh)), s, t, Empty)
  | balance (Tr (B, Tr (B, vf, vg, vh, vi), vb, vc, vd)) s t Empty =
    Tr (B, Tr (B, Tr (B, vf, vg, vh, vi), vb, vc, vd), s, t, Empty)
  | balance (Tr (v, Tr (B, vf, vg, vh, vi), vb, vc, Empty)) s t Empty =
    Tr (B, Tr (v, Tr (B, vf, vg, vh, vi), vb, vc, Empty), s, t, Empty)
  | balance (Tr (v, Tr (B, vf, vg, vh, vi), vb, vc, Tr (B, ve, vj, vk, vl))) s t
    Empty =
    Tr (B, Tr (v, Tr (B, vf, vg, vh, vi), vb, vc, Tr (B, ve, vj, vk, vl)), s, t,
         Empty)
  | balance Empty s t (Tr (B, va, vb, vc, vd)) =
    Tr (B, Empty, s, t, Tr (B, va, vb, vc, vd))
  | balance (Tr (B, ve, vf, vg, vh)) s t (Tr (B, va, vb, vc, vd)) =
    Tr (B, Tr (B, ve, vf, vg, vh), s, t, Tr (B, va, vb, vc, vd))
  | balance (Tr (B, Empty, vf, vg, vh)) s t (Tr (B, va, vb, vc, vd)) =
    Tr (B, Tr (B, Empty, vf, vg, vh), s, t, Tr (B, va, vb, vc, vd))
  | balance (Tr (v, Empty, vf, vg, Empty)) s t (Tr (B, va, vb, vc, vd)) =
    Tr (B, Tr (v, Empty, vf, vg, Empty), s, t, Tr (B, va, vb, vc, vd))
  | balance (Tr (v, Empty, vf, vg, Tr (B, vi, vj, vk, vl))) s t
    (Tr (B, va, vb, vc, vd)) =
    Tr (B, Tr (v, Empty, vf, vg, Tr (B, vi, vj, vk, vl)), s, t,
         Tr (B, va, vb, vc, vd))
  | balance (Tr (B, Tr (B, vj, vk, vl, vm), vf, vg, vh)) s t
    (Tr (B, va, vb, vc, vd)) =
    Tr (B, Tr (B, Tr (B, vj, vk, vl, vm), vf, vg, vh), s, t,
         Tr (B, va, vb, vc, vd))
  | balance (Tr (v, Tr (B, vj, vk, vl, vm), vf, vg, Empty)) s t
    (Tr (B, va, vb, vc, vd)) =
    Tr (B, Tr (v, Tr (B, vj, vk, vl, vm), vf, vg, Empty), s, t,
         Tr (B, va, vb, vc, vd))
  | balance (Tr (v, Tr (B, vj, vk, vl, vm), vf, vg, Tr (B, vi, vn, vo, vp))) s t
    (Tr (B, va, vb, vc, vd)) =
    Tr (B, Tr (v, Tr (B, vj, vk, vl, vm), vf, vg, Tr (B, vi, vn, vo, vp)), s, t,
         Tr (B, va, vb, vc, vd));

type 'a preorder = {ord_preorder : 'a ord};
fun ord_preorder (A_:'a preorder) = #ord_preorder A_;

type 'a order = {preorder_order : 'a preorder};
fun preorder_order (A_:'a order) = #preorder_order A_;

type 'a linorder = {order_linorder : 'a order};
fun order_linorder (A_:'a linorder) = #order_linorder A_;

fun ins A_ f k v Empty = Tr (R, Empty, k, v, Empty)
  | ins A_ f k v (Tr (B, l, x, y, r)) =
    (if less ((ord_preorder o preorder_order o order_linorder) A_) k x
      then balance (ins A_ f k v l) x y r
      else (if less ((ord_preorder o preorder_order o order_linorder) A_) x k
             then balance l x y (ins A_ f k v r) else Tr (B, l, x, f k y v, r)))
  | ins A_ f k v (Tr (R, l, x, y, r)) =
    (if less ((ord_preorder o preorder_order o order_linorder) A_) k x
      then Tr (R, ins A_ f k v l, x, y, r)
      else (if less ((ord_preorder o preorder_order o order_linorder) A_) x k
             then Tr (R, l, x, y, ins A_ f k v r)
             else Tr (R, l, x, f k y v, r)));

fun rhsl (Rule (q, l, qs)) = l;

fun rhsq (Rule (q, l, qs)) = qs;

datatype ('a, 'b) ustate_wrapper = USW1 of 'a | USW2 of 'b;

fun map f [] = []
  | map f (x :: xs) = f x :: map f xs;

fun foldl f a [] = a
  | foldl f a (x :: xs) = foldl f (f a x) xs;

fun rev xs = foldl (fn xsa => fn x => x :: xsa) [] xs;

fun list_case f1 f2 (a :: lista) = f2 a lista
  | list_case f1 f2 [] = f1;

fun zip xs [] = []
  | zip xs (y :: ys) = (case xs of [] => [] | z :: zs => (z, y) :: zip zs ys);

datatype 'a tree = Node of 'a * 'a tree list;

fun null [] = true
  | null (x :: xs) = false;

fun revg [] b = b
  | revg (a :: asa) b = revg asa (a :: b);

val eq_nat = {eq = (fn a => fn b => ((a : IntInf.int) = b))} : IntInf.int eq;

fun paint c Empty = Empty
  | paint c (Tr (uu, l, k, v, r)) = Tr (c, l, k, v, r);

fun insertwithkey A_ f k v t = paint B (ins A_ f k v t);

fun insrt A_ k v t = insertwithkey A_ (fn _ => fn _ => fn nv => nv) k v t;

fun r_prod (Rule (q1, l1, qs1)) (Rule (q2, l2, qs2)) =
  Rule ((q1, q2), l1, zip qs1 qs2);

val ord_int =
  {less_eq = (fn a => fn b => IntInf.<= (a, b)),
    less = (fn a => fn b => IntInf.< (a, b))}
  : IntInf.int ord;

fun map_of A_ ((l, v) :: ps) k = (if eqa A_ l k then SOME v else map_of A_ ps k)
  | map_of A_ [] k = NONE;

fun the (SOME x) = x;

fun map_ofa A_ Empty k = NONE
  | map_ofa A_ (Tr (uu, l, x, y, r)) k =
    (if less ((ord_preorder o preorder_order o order_linorder) A_) k x
      then map_ofa A_ l k
      else (if less ((ord_preorder o preorder_order o order_linorder) A_) x k
             then map_ofa A_ r k else SOME y));

fun inj_image_filter_cp iterate1 iterate2 empty3 insert_dj3 f p s1 s2 =
  iterate1
    (fn x =>
      iterate2
        (fn y => fn res => (if p x y then insert_dj3 (f x y) res else res))
        s2)
    s1
    empty3;

fun cart it1 it2 empty3 ins3 s1 s2 =
  inj_image_filter_cp it1 it2 empty3 ins3 (fn a => fn b => (a, b))
    (fn _ => fn _ => true) s1 s2;

fun eq_list A_ [] [] = true
  | eq_list A_ (a :: lista) (a' :: list') =
    eqa A_ a a' andalso eq_list A_ lista list'
  | eq_list A_ [] (a' :: list') = false
  | eq_list A_ (a' :: list') [] = false;

fun eq_lista A_ = {eq = eq_list A_} : ('a list) eq;

fun member A_ x [] = false
  | member A_ x (y :: ys) = eqa A_ x y orelse member A_ x ys;

datatype ('a, 'b, 'c) tuple_isomorphism =
  TupleIsomorphism of ('a -> 'b * 'c) * ('b * 'c -> 'a);

fun abst (TupleIsomorphism (r, a)) = a;

fun repr (TupleIsomorphism (r, a)) = r;

val preorder_int = {ord_preorder = ord_int} : IntInf.int preorder;

val order_int = {preorder_order = preorder_int} : IntInf.int order;

fun remdups A_ [] = []
  | remdups A_ (x :: xs) =
    (if member A_ x xs then remdups A_ xs else x :: remdups A_ xs);

fun it_add update iterate m1 m2 = iterate update m2 m1;

fun eq_ta_rule A_ B_ (Rule (q, l, lista)) (Rule (q', l', list')) =
  eqa A_ q q' andalso (eqa B_ l l' andalso eq_list A_ lista list');

fun eq_ta_rulea A_ B_ = {eq = eq_ta_rule A_ B_} : ('a, 'b) ta_rule eq;

fun snd (a, b) = b;

fun fst (a, b) = a;

fun fifo_get f =
  (case snd f of [] => let
                         val rp = rev (fst f);
                       in
                         (hd rp, ([], tl rp))
                       end
    | a :: l => (a, (fst f, l)));

fun fifo_put a f = (a :: fst f, snd f);

fun list_all p [] = true
  | list_all p (x :: xs) = p x andalso list_all p xs;

fun is_none (SOME x) = false
  | is_none NONE = true;

fun iti_sel iti m f = iti is_none (fn k => fn v => fn _ => f k v) m NONE;

fun map_sng empt update k v = update k v empt;

fun minus_nat n m = IntInf.max (0, (IntInf.- (n, m)));

fun it_size iterate s = iterate (fn _ => suc) s (0 : IntInf.int);

fun remap_rule f (Rule (q, l, qs)) = Rule (f q, l, map f qs);

val linorder_int = {order_linorder = order_int} : IntInf.int linorder;

fun lm_iterate_code f [] sigma = sigma
  | lm_iterate_code f ((k, v) :: l) sigma = lm_iterate_code f l (f k v sigma);

fun lm_iterate x = lm_iterate_code x;

fun foldwithkey A_ f Empty v = v
  | foldwithkey A_ f (Tr (c, lt, k, x, rt)) v =
    foldwithkey A_ f rt (f k x (foldwithkey A_ f lt v));

fun rm_iterate A_ f t sigma_0 = foldwithkey A_ f t sigma_0;

fun hm_iterate D_ f m sigma_0 = rm_iterate D_ (fn _ => lm_iterate f) m sigma_0;

fun rm_lookup A_ k m = map_ofa A_ m k;

fun update A_ k v [] = [(k, v)]
  | update A_ k v (p :: ps) =
    (if eqa A_ (fst p) k then (k, v) :: ps else p :: update A_ k v ps);

fun lm_update A_ = update A_;

val lm_empty : 'a list = [];

fun lm_sng A_ = map_sng lm_empty (lm_update A_);

fun rm_update A_ = insrt A_;

fun option_case f1 f2 (SOME a) = f2 a
  | option_case f1 f2 NONE = f1;

type 'a hashable = {hashcode : 'a -> IntInf.int};
fun hashcode (A_:'a hashable) = #hashcode A_;

fun hm_update (A1_, A2_) k v m =
  let
    val hc = hashcode A2_ k;
  in
    (case rm_lookup linorder_int hc m
      of NONE => rm_update linorder_int hc (lm_sng A1_ k v) m
      | SOME bm => rm_update linorder_int hc (lm_update A1_ k v bm) m)
  end;

fun hm_add (A1_, A2_) = it_add (hm_update (A1_, A2_)) (hm_iterate linorder_int);

fun lm_iteratei c f [] sigma = sigma
  | lm_iteratei c f ((k, v) :: l) sigma =
    (if c sigma then lm_iteratei c f l (f k v sigma) else sigma);

fun lm_sel x = iti_sel lm_iteratei x;

fun rm_iteratei c f Empty sigma = sigma
  | rm_iteratei c f (Tr (col, l, k, v, r)) sigma =
    (if c sigma then rm_iteratei c f l (rm_iteratei c f r (f k v sigma))
      else sigma);

fun rm_sel x = iti_sel rm_iteratei x;

fun hm_sel A_ m f = rm_sel m (fn _ => fn lm => lm_sel lm f);

fun s_ins update x s = update x () s;

fun hs_ins (A1_, A2_) = s_ins (hm_update (A1_, A2_));

fun s_sel sel s f = sel s (fn u => fn _ => f u);

fun hs_sel A_ = s_sel (hm_sel A_);

fun size_list [] = (0 : IntInf.int)
  | size_list (a :: lista) = IntInf.+ (size_list lista, suc (0 : IntInf.int));

fun eqb A_ B_ (x1, y1) (x2, y2) = eqa A_ x1 x2 andalso eqa B_ y1 y2;

fun eqc A_ B_ = {eq = eqb A_ B_} : ('a * 'b) eq;

fun it_inter iterate1 memb2 empt3 insrt3 s1 s2 =
  iterate1 (fn x => fn s => (if memb2 x s2 then insrt3 x s else s)) s1 empt3;

fun it_union iterate1 insrt2 s1 s2 = iterate1 insrt2 s1 s2;

val rm_empty : ('a, 'b) rbt = Empty;

val hm_empty : ('a, 'b) rbt = rm_empty;

fun s_empty empt = empt;

fun hs_empty A_ = s_empty hm_empty;

fun ls_iteratei c f [] sigma = sigma
  | ls_iteratei c f (x :: l) sigma =
    (if c sigma then ls_iteratei c f l (f x sigma) else sigma);

fun iti_iterate iti = iti (fn _ => true);

fun ls_iterate x = iti_iterate ls_iteratei x;

fun it_image_filter iterate1 empty2 ins2 f s =
  iterate1 (fn x => fn res => (case f x of NONE => res | SOME v => ins2 v res))
    s
    empty2;

fun lh_image_filter (B1_, B2_) =
  it_image_filter ls_iterate (hs_empty B2_) (hs_ins (B1_, B2_));

fun brc_iq (A1_, A2_) delta =
  lh_image_filter (A1_, A2_)
    (fn r => (if null (rhsq r) then SOME (lhs r) else NONE)) delta;

datatype ('a, 'b, 'c) hashedTa_ext_type =
  Abs_hashedTa_ext_type of
    ((((IntInf.int, (('a * unit) list)) rbt * ('a, 'b) ta_rule list) *
       ((IntInf.int, (('b * ('a, 'b) ta_rule list) list)) rbt option *
         ((IntInf.int, (('a * ('a, 'b) ta_rule list) list)) rbt option *
           (IntInf.int, ((('a * 'b) * ('a, 'b) ta_rule list) list))
             rbt option)))
      * 'c);

fun rep_hashedTa_ext_type (Abs_hashedTa_ext_type y) = y;

val hashedTa_ext_type_TupleIsom :
  (('a, 'b, 'c) hashedTa_ext_type,
    (((IntInf.int, (('a * unit) list)) rbt * ('a, 'b) ta_rule list) *
      ((IntInf.int, (('b * ('a, 'b) ta_rule list) list)) rbt option *
        ((IntInf.int, (('a * ('a, 'b) ta_rule list) list)) rbt option *
          (IntInf.int, ((('a * 'b) * ('a, 'b) ta_rule list) list))
            rbt option))),
    'c)
    tuple_isomorphism
  = TupleIsomorphism (rep_hashedTa_ext_type, Abs_hashedTa_ext_type);

fun istuple_snd isom = snd o repr isom;

val tuple_istuple : (('a * 'b), 'a, 'b) tuple_isomorphism =
  TupleIsomorphism (id, id);

fun istuple_fst isom = fst o repr isom;

fun hta_idx_f x =
  (id o istuple_fst tuple_istuple o istuple_snd tuple_istuple o
    istuple_fst hashedTa_ext_type_TupleIsom)
    x;

val ls_empty : 'a list = [];

fun lm_lookup A_ k m = map_of A_ m k;

fun hm_lookup (A1_, A2_) k m =
  (case rm_lookup linorder_int (hashcode A2_ k) m of NONE => NONE
    | SOME a => lm_lookup A1_ k a);

fun idx_lookup mlookup tempty i m =
  (case mlookup i m of NONE => tempty | SOME s => s);

fun hl_idx_lookup (A1_, A2_) = idx_lookup (hm_lookup (A1_, A2_)) ls_empty;

fun hta_lookup_f (A1_, A2_) f h =
  hl_idx_lookup (A1_, A2_) f (the (hta_idx_f h));

fun ls_memb A_ = member A_;

fun list_all_zip p [] [] = true
  | list_all_zip p (a :: asa) (b :: bs) = p a b andalso list_all_zip p asa bs
  | list_all_zip p (v :: va) [] = false
  | list_all_zip p [] (v :: va) = false;

fun ta_rule_case f1 (Rule (q, l, lista)) = f1 q l lista;

fun ls_ins A_ x l = (if member A_ x l then l else x :: l);

fun ls_image_filter B_ = it_image_filter ls_iterate ls_empty (ls_ins B_);

fun faccs' A_ (B1_, B2_) h (Node (f, ts)) =
  let
    val qs = map (faccs' A_ (B1_, B2_) h) ts;
  in
    ls_image_filter A_
      (fn r =>
        let
          val Rule (_, _, qsa) = r;
        in
          (if list_all_zip (fn q => fn qa => ls_memb A_ qa q) qs qsa
            then SOME (lhs r) else NONE)
        end)
      (hta_lookup_f (B1_, B2_) f h)
  end;

fun hta_Qi x =
  (id o istuple_fst tuple_istuple o istuple_fst tuple_istuple o
    istuple_fst hashedTa_ext_type_TupleIsom)
    x;

val fifo_empty : 'a list * 'a list = ([], []);

fun s_memb lookup x s = not (is_none (lookup x s));

fun hs_memb (A1_, A2_) = s_memb (hm_lookup (A1_, A2_));

fun s_iterate iterate f s sigma_0 = iterate (fn k => fn _ => f k) s sigma_0;

fun hs_iterate A_ = s_iterate (hm_iterate linorder_int);

fun hs_size A_ = it_size (hs_iterate A_);

fun idx_build_stepfun mlookup mupdate tempty tinsert f x m =
  let
    val i = f x;
  in
    (case mlookup i m of NONE => mupdate i (tinsert x tempty) m
      | SOME s => mupdate i (tinsert x s) m)
  end;

fun idx_build mempty mlookup mupdate tempty tinsert siterate f s =
  siterate (idx_build_stepfun mlookup mupdate tempty tinsert f) s mempty;

fun hta_delta x =
  (id o istuple_snd tuple_istuple o istuple_fst tuple_istuple o
    istuple_fst hashedTa_ext_type_TupleIsom)
    x;

fun hll_idx_build A_ (B1_, B2_) =
  idx_build hm_empty (hm_lookup (B1_, B2_)) (hm_update (B1_, B2_)) ls_empty
    (ls_ins A_) ls_iterate;

fun build_rule_index A_ B_ (C1_, C2_) =
  hll_idx_build (eq_ta_rulea A_ B_) (C1_, C2_);

fun build_rule_index_f A_ (B1_, B2_) delta =
  build_rule_index A_ B1_ (B1_, B2_) rhsl delta;

fun apsnd f (x, y) = (x, f y);

fun istuple_snd_update isom f = abst isom o apsnd f o repr isom;

fun apfst f (x, y) = (f x, y);

fun istuple_fst_update isom f = abst isom o apfst f o repr isom;

fun hta_idx_f_update x =
  (istuple_fst_update hashedTa_ext_type_TupleIsom o
    (istuple_snd_update tuple_istuple o
      (istuple_fst_update tuple_istuple o id)))
    x;

fun hta_ensure_idx_f A_ (B1_, B2_) h =
  (case hta_idx_f h
    of NONE =>
      hta_idx_f_update
        (fn _ => SOME (build_rule_index_f A_ (B1_, B2_) (hta_delta h))) h
    | SOME _ => h);

fun ls_ball l p = list_all p l;

fun ball_disjoint ball1 memb2 s1 s2 = ball1 s1 (fn x => not (memb2 x s2));

fun lh_disjoint (A1_, A2_) = ball_disjoint ls_ball (hs_memb (A1_, A2_));

fun hta_mem' (A1_, A2_) (B1_, B2_) t h =
  not (lh_disjoint (B1_, B2_) (faccs' B1_ (A1_, A2_) h t) (hta_Qi h));

fun hta_mem (A1_, A2_) (B1_, B2_) t h =
  hta_mem' (A1_, A2_) (B1_, B2_) t (hta_ensure_idx_f B1_ (A1_, A2_) h);

fun split f (a, b) = f a b;

fun pa_cond A_ B_ C_ s = let
                           val (_, (w, _)) = s;
                         in
                           not (null w)
                         end;

fun hta_idx_s x =
  (id o istuple_fst tuple_istuple o istuple_snd tuple_istuple o
     istuple_snd tuple_istuple
    o istuple_fst hashedTa_ext_type_TupleIsom)
    x;

fun hta_lookup_s (A1_, A2_) q h =
  hl_idx_lookup (A1_, A2_) q (the (hta_idx_s h));

fun hta_idx_sf x =
  (id o istuple_snd tuple_istuple o istuple_snd tuple_istuple o
     istuple_snd tuple_istuple
    o istuple_fst hashedTa_ext_type_TupleIsom)
    x;

fun prod_case f1 (a, b) = f1 a b;

fun hashcodea A_ B_ x =
  let
    val (a, b) = x;
  in
    IntInf.+ (hashcode A_ a, hashcode B_ b)
  end;

fun hashable A_ B_ = {hashcode = hashcodea A_ B_} : ('a * 'b) hashable;

fun hta_lookup_sf (A1_, A2_) (B1_, B2_) q f h =
  hl_idx_lookup (eqc A1_ B1_, hashable A2_ B2_) (q, f) (the (hta_idx_sf h));

fun ls_ins_dj x l = x :: l;

fun pa_upd_rule (A1_, A2_) (B1_, B2_) q w [] = (q, w)
  | pa_upd_rule (A1_, A2_) (B1_, B2_) q w (qp :: qs) =
    (if not (hs_memb (eqc A1_ B1_, hashable A2_ B2_) qp q)
      then pa_upd_rule (A1_, A2_) (B1_, B2_)
             (hs_ins (eqc A1_ B1_, hashable A2_ B2_) qp q) (qp :: w) qs
      else pa_upd_rule (A1_, A2_) (B1_, B2_) q w qs);

fun pa_step (A1_, A2_) (B1_, B2_) (C1_, C2_) h1 h2 s =
  let
    val (q, (w, delta_d)) = s;
    val (q1, q2) = hd w;
  in
    ls_iterate
      (fn r1 =>
        ls_iterate
          (fn r2 => fn res =>
            (if (((size_list (rhsq r1)) : IntInf.int) = (size_list (rhsq r2)))
              then let
                     val rp = r_prod r1 r2;
                     val (qa, (wa, delta_da)) = res;
                     val (q', w') =
                       pa_upd_rule (A1_, A2_) (C1_, C2_) qa wa (rhsq rp);
                   in
                     (q', (w', ls_ins_dj rp delta_da))
                   end
              else res))
          (hta_lookup_sf (C1_, C2_) (B1_, B2_) q2 (rhsl r1) h2))
      (hta_lookup_s (A1_, A2_) q1 h1) (q, (tl w, delta_d))
  end;

fun map_to_nat iterate1 empty2 update2 s =
  snd (iterate1
         (fn x => fn (c, m) => (IntInf.+ (c, (1 : IntInf.int)), update2 x c m))
         s
        ((0 : IntInf.int), empty2));

fun hs_image_filter A_ (B1_, B2_) =
  it_image_filter (hs_iterate A_) (hs_empty B2_) (hs_ins (B1_, B2_));

fun iflt_image iflt f s = iflt (fn x => SOME (f x)) s;

fun hs_image A_ (B1_, B2_) = iflt_image (hs_image_filter A_ (B1_, B2_));

fun hm_update_dj (A1_, A2_) = hm_update (A1_, A2_);

fun s_ins_dj update_dj x s = update_dj x () s;

fun hs_ins_dj (A1_, A2_) = s_ins_dj (hm_update_dj (A1_, A2_));

fun hs_inter (A1_, A2_) =
  it_inter (hs_iterate A2_) (hs_memb (A1_, A2_)) (hs_empty A2_)
    (hs_ins_dj (A1_, A2_));

fun s_union add = add;

fun hs_union (A1_, A2_) = s_union (hm_add (A1_, A2_));

fun hhh_cart (A1_, A2_) (B1_, B2_) =
  cart (hs_iterate A2_) (hs_iterate B2_) (hs_empty (hashable A2_ B2_))
    (hs_ins_dj (eqc A1_ B1_, hashable A2_ B2_));

fun brc_cond A_ B_ = (fn (_, (w, _)) => not (null w));

fun rqrm_lookup (A1_, A2_) rqrm q =
  (case hm_lookup (A1_, A2_) q rqrm of NONE => ls_empty | SOME s => s);

fun hashcode_of_list A_ [] = (0 : IntInf.int)
  | hashcode_of_list A_ (x :: xs) =
    IntInf.+ (hashcode A_ x, hashcode_of_list A_ xs);

fun hashcode_list A_ = hashcode_of_list A_;

fun hashcode_of_ta_rule A_ B_ (Rule (q, f, qs)) =
  IntInf.+ (IntInf.+ (hashcode A_ q, hashcode B_ f), hashcode_list A_ qs);

fun hashcode_ta_rule A_ B_ = hashcode_of_ta_rule A_ B_;

fun hashable_ta_rule A_ B_ = {hashcode = hashcode_ta_rule A_ B_} :
  ('a, 'b) ta_rule hashable;

fun brc_inner_step (A1_, A2_) (B1_, B2_) r =
  (fn (q, (w, rcm)) =>
    let
      val c =
        the (hm_lookup (eq_ta_rulea A1_ B1_, hashable_ta_rule A2_ B2_) r rcm);
      val rcm' =
        hm_update (eq_ta_rulea A1_ B1_, hashable_ta_rule A2_ B2_) r
          (minus_nat c (1 : IntInf.int)) rcm;
      val q' =
        (if IntInf.<= (c, (1 : IntInf.int)) then hs_ins (A1_, A2_) (lhs r) q
          else q);
      val w' =
        (if IntInf.<= (c, (1 : IntInf.int)) andalso
              not (hs_memb (A1_, A2_) (lhs r) q)
          then lhs r :: w else w);
    in
      (q', (w', rcm'))
    end);

fun brc_step (A1_, A2_) (B1_, B2_) rqrm =
  (fn (q, (w, rcm)) =>
    ls_iterate (brc_inner_step (A1_, A2_) (B1_, B2_))
      (rqrm_lookup (A1_, A2_) rqrm (hd w)) (q, (tl w, rcm)));

fun brec_iqm (A1_, A2_) B_ delta =
  ls_iterate
    (fn r => fn m =>
      (if null (rhsq r) then hm_update (A1_, A2_) (lhs r) (Node (rhsl r, [])) m
        else m))
    delta hm_empty;

fun build_rule_index_sf (A1_, A2_) (B1_, B2_) delta =
  build_rule_index A1_ B1_ (eqc A1_ B1_, hashable A2_ B2_)
    (fn r => (lhs r, rhsl r)) delta;

fun hta_idx_sf_update x =
  (istuple_fst_update hashedTa_ext_type_TupleIsom o
    (istuple_snd_update tuple_istuple o
      (istuple_snd_update tuple_istuple o
        (istuple_snd_update tuple_istuple o id))))
    x;

fun hta_ensure_idx_sf (A1_, A2_) (B1_, B2_) h =
  (case hta_idx_sf h
    of NONE =>
      hta_idx_sf_update
        (fn _ => SOME (build_rule_index_sf (A1_, A2_) (B1_, B2_) (hta_delta h)))
        h
    | SOME _ => h);

fun build_rule_index_s (A1_, A2_) B_ delta =
  build_rule_index A1_ B_ (A1_, A2_) lhs delta;

fun hta_idx_s_update x =
  (istuple_fst_update hashedTa_ext_type_TupleIsom o
    (istuple_snd_update tuple_istuple o
      (istuple_snd_update tuple_istuple o
        (istuple_fst_update tuple_istuple o id))))
    x;

fun hta_ensure_idx_s (A1_, A2_) B_ h =
  (case hta_idx_s h
    of NONE =>
      hta_idx_s_update
        (fn _ => SOME (build_rule_index_s (A1_, A2_) B_ (hta_delta h))) h
    | SOME _ => h);

fun curry f a b = f (a, b);

fun istuple_cons isom = curry (abst isom);

fun hashedTa_ext hta_Qi hta_delta hta_idx_f hta_idx_s hta_idx_sf more =
  istuple_cons hashedTa_ext_type_TupleIsom
    (istuple_cons tuple_istuple (istuple_cons tuple_istuple hta_Qi hta_delta)
      (istuple_cons tuple_istuple hta_idx_f
        (istuple_cons tuple_istuple hta_idx_s hta_idx_sf)))
    more;

fun init_hta qi delta = hashedTa_ext qi delta NONE NONE NONE ();

fun it_set_to_list iterate s = iterate (fn a => fn b => a :: b) s [];

fun hs_to_list A_ = it_set_to_list (hs_iterate A_);

fun pa_initial (A1_, A2_) B_ (C1_, C2_) h1 h2 =
  let
    val qip = hhh_cart (A1_, A2_) (C1_, C2_) (hta_Qi h1) (hta_Qi h2);
  in
    (qip, (hs_to_list (hashable A2_ C2_) qip, ls_empty))
  end;

fun whilea b c s = (if b s then whilea b c (c s) else s);

fun hta_prod' (A1_, A2_) (B1_, B2_) (C1_, C2_) h1 h2 =
  let
    val (_, (_, a)) =
      whilea (pa_cond A2_ C2_ B2_)
        (pa_step (A1_, A2_) (B1_, B2_) (C1_, C2_) h1 h2)
        (pa_initial (A1_, A2_) B2_ (C1_, C2_) h1 h2);
  in
    init_hta (hhh_cart (A1_, A2_) (C1_, C2_) (hta_Qi h1) (hta_Qi h2)) a
  end;

fun hta_prod (A1_, A2_) (B1_, B2_) (C1_, C2_) h1 h2 =
  hta_prod' (A1_, A2_) (B1_, B2_) (C1_, C2_)
    (hta_ensure_idx_s (A1_, A2_) B1_ h1)
    (hta_ensure_idx_sf (C1_, C2_) (B1_, B2_) h2);

fun hashcode_nat i = i;

val hashable_nat = {hashcode = hashcode_nat} : IntInf.int hashable;

fun htai_mem x = hta_mem (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;

fun rqrm_add (A1_, A2_) B_ q r res =
  (case hm_lookup (A1_, A2_) q res
    of NONE => hm_update (A1_, A2_) q (ls_ins B_ r ls_empty) res
    | SOME s => hm_update (A1_, A2_) q (ls_ins B_ r s) res);

fun fifo_isEmpty A_ f = eqb (eq_lista A_) (eq_lista A_) f ([], []);

fun lhh_union (A1_, A2_) = it_union ls_iterate (hs_ins (A1_, A2_));

fun brec_cond A_ =
  (fn (_, (w, (_, qwit))) => not (fifo_isEmpty A_ w) andalso is_none qwit);

fun brec_construct_witness (A1_, A2_) B_ qm r =
  Node (rhsl r, map (fn q => the (hm_lookup (A1_, A2_) q qm)) (rhsq r));

fun brec_inner_step (A1_, A2_) (B1_, B2_) qi r =
  (fn (q, (w, (rcm, qwit))) =>
    let
      val c =
        the (hm_lookup (eq_ta_rulea A1_ B1_, hashable_ta_rule A2_ B2_) r rcm);
      val cond =
        IntInf.<= (c, (1 : IntInf.int)) andalso
          is_none (hm_lookup (A1_, A2_) (lhs r) q);
      val rcm' =
        hm_update (eq_ta_rulea A1_ B1_, hashable_ta_rule A2_ B2_) r
          (minus_nat c (1 : IntInf.int)) rcm;
      val q' =
        (if cond
          then hm_update (A1_, A2_) (lhs r)
                 (brec_construct_witness (A1_, A2_) B2_ q r) q
          else q);
      val w' = (if cond then fifo_put (lhs r) w else w);
      val qwit' =
        (if IntInf.<= (c, (1 : IntInf.int)) andalso
              hs_memb (A1_, A2_) (lhs r) qi
          then SOME (lhs r) else qwit);
    in
      (q', (w', (rcm', qwit')))
    end);

fun brec_step (A1_, A2_) (B1_, B2_) rqrm qi =
  (fn (q, (w, (rcm, qwit))) =>
    let
      val (qa, w') = fifo_get w;
    in
      ls_iterate (brec_inner_step (A1_, A2_) (B1_, B2_) qi)
        (rqrm_lookup (A1_, A2_) rqrm qa) (q, (w', (rcm, qwit)))
    end);

fun hta_empty A_ B_ = init_hta (hs_empty A_) ls_empty;

fun ls_image B_ = iflt_image (ls_image_filter B_);

fun hta_remap A_ (B1_, B2_) (C1_, C2_) f h =
  init_hta (hs_image A_ (B1_, B2_) f (hta_Qi h))
    (ls_image (eq_ta_rulea B1_ C1_) (remap_rule f) (hta_delta h));

fun ls_union_dj s1 s2 = revg s1 s2;

fun hashcode_of_usw A_ B_ (USW1 q) = hashcode A_ q
  | hashcode_of_usw A_ B_ (USW2 q) = hashcode B_ q;

fun hashcode_ustate_wrapper A_ B_ = hashcode_of_usw A_ B_;

fun hashable_ustate_wrapper A_ B_ = {hashcode = hashcode_ustate_wrapper A_ B_} :
  ('a, 'b) ustate_wrapper hashable;

fun eq_ustate_wrapper A_ B_ (USW1 q1) (USW1 q1') = eqa A_ q1 q1'
  | eq_ustate_wrapper A_ B_ (USW2 q2) (USW2 q2') = eqa B_ q2 q2'
  | eq_ustate_wrapper A_ B_ (USW1 q1) (USW2 q2') = false
  | eq_ustate_wrapper A_ B_ (USW2 q2') (USW1 q1) = false;

fun eq_ustate_wrappera A_ B_ = {eq = eq_ustate_wrapper A_ B_} :
  ('a, 'b) ustate_wrapper eq;

fun hta_union (A1_, A2_) (B1_, B2_) (C1_, C2_) h1 h2 =
  init_hta
    (hs_union (eq_ustate_wrappera A1_ C1_, hashable_ustate_wrapper A2_ C2_)
      (hs_image A2_
        (eq_ustate_wrappera A1_ C1_, hashable_ustate_wrapper A2_ C2_) USW1
        (hta_Qi h1))
      (hs_image C2_
        (eq_ustate_wrappera A1_ C1_, hashable_ustate_wrapper A2_ C2_) USW2
        (hta_Qi h2)))
    (ls_union_dj
      (ls_image (eq_ta_rulea (eq_ustate_wrappera A1_ C1_) B1_) (remap_rule USW1)
        (hta_delta h1))
      (ls_image (eq_ta_rulea (eq_ustate_wrappera A1_ C1_) B1_) (remap_rule USW2)
        (hta_delta h2)));

fun list_to_ls A_ = remdups A_;

fun rule_states_l A_ (Rule (q, f, qs)) = ls_ins A_ q (list_to_ls A_ qs);

fun it_Union_image it1 em3 un233 f s = it1 (fn x => un233 (f x)) s em3;

fun llh_Union_image (B1_, B2_) =
  it_Union_image ls_iterate (hs_empty B2_) (lhh_union (B1_, B2_));

fun hta_delta_states (A1_, A2_) h =
  llh_Union_image (A1_, A2_) id
    (ls_image_filter (eq_lista A1_) (fn r => SOME (rule_states_l A1_ r))
      (hta_delta h));

fun hta_states (A1_, A2_) h =
  hs_union (A1_, A2_) (hta_Qi h) (hta_delta_states (A1_, A2_) h);

fun hh_map_to_nat (A1_, A2_) =
  map_to_nat (hs_iterate A2_) hm_empty (hm_update (A1_, A2_));

fun hta_reindex (A1_, A2_) (B1_, B2_) h =
  let
    val mp = hh_map_to_nat (A1_, A2_) (hta_states (A1_, A2_) h);
  in
    hta_remap A2_ (eq_nat, hashable_nat) (B1_, B2_)
      (fn q => the (hm_lookup (A1_, A2_) q mp)) h
  end;

fun htai_prod h1 h2 =
  hta_reindex (eqc eq_nat eq_nat, hashable hashable_nat hashable_nat)
    (eq_nat, hashable_nat)
    (hta_prod (eq_nat, hashable_nat) (eq_nat, hashable_nat)
      (eq_nat, hashable_nat) h1 h2);

fun length_unique A_ [] = (0 : IntInf.int)
  | length_unique A_ (x :: xs) =
    (if member A_ x xs then length_unique A_ xs else suc (length_unique A_ xs));

fun rs_iterate A_ = s_iterate (rm_iterate A_);

fun rs_size A_ = it_size (rs_iterate A_);

fun it_set_to_fifo iterate s = iterate fifo_put s fifo_empty;

fun hs_to_fifo A_ = it_set_to_fifo (hs_iterate A_);

fun build_rqrm (A1_, A2_) (B1_, B2_) delta =
  ls_iterate
    (fn r => fn res =>
      foldl (fn resa => fn q =>
              rqrm_add (A1_, A2_) (eq_ta_rulea A1_ B1_) q r resa)
        res (rhsq r))
    delta hm_empty;

fun hta_add_qi (A1_, A2_) B_ qi h =
  init_hta (hs_ins (A1_, A2_) qi (hta_Qi h)) (hta_delta h);

fun lll_inj_image_filter_cp x =
  inj_image_filter_cp ls_iterate ls_iterate ls_empty ls_ins_dj x;

fun delta_prod_h A_ (B1_, B2_) C_ delta_1 delta_2 =
  lll_inj_image_filter_cp r_prod
    (fn r1 => fn r2 =>
      eqa B1_ (rhsl r1) (rhsl r2) andalso
        (((size_list (rhsq r1)) : IntInf.int) = (size_list (rhsq r2))))
    delta_1 delta_2;

fun hta_prodWR (A1_, A2_) (B1_, B2_) (D1_, D2_) h1 h2 =
  init_hta (hhh_cart (A1_, A2_) (D1_, D2_) (hta_Qi h1) (hta_Qi h2))
    (delta_prod_h A2_ (B1_, B2_) D2_ (hta_delta h1) (hta_delta h2));

fun hta_reduce (A1_, A2_) B_ h q =
  init_hta (hs_inter (A1_, A2_) q (hta_Qi h))
    (ls_image_filter (eq_ta_rulea A1_ B_)
      (fn r =>
        (if hs_memb (A1_, A2_) (lhs r) q andalso
              list_all (fn qa => hs_memb (A1_, A2_) qa q) (rhsq r)
          then SOME r else NONE))
      (hta_delta h));

val htai_empty : (IntInf.int, IntInf.int, unit) hashedTa_ext_type =
  hta_empty hashable_nat hashable_nat;

fun htai_union h1 h2 =
  hta_reindex
    (eq_ustate_wrappera eq_nat eq_nat,
      hashable_ustate_wrapper hashable_nat hashable_nat)
    (eq_nat, hashable_nat)
    (hta_union (eq_nat, hashable_nat) (eq_nat, hashable_nat)
      (eq_nat, hashable_nat) h1 h2);

fun ls_size x = it_size ls_iterate x;

fun brc_rcm_init (A1_, A2_) (B1_, B2_) delta =
  ls_iterate
    (fn r =>
      hm_update (eq_ta_rulea A1_ B1_, hashable_ta_rule A2_ B2_) r
        (length_unique A1_ (rhsq r)))
    delta hm_empty;

fun brc_initial (A1_, A2_) (B1_, B2_) delta =
  let
    val iq = brc_iq (A1_, A2_) delta;
  in
    (iq, (hs_to_list A2_ iq, brc_rcm_init (A1_, A2_) (B1_, B2_) delta))
  end;

fun htai_add_qi x = hta_add_qi (eq_nat, hashable_nat) hashable_nat x;

fun htai_prodWR h1 h2 =
  hta_reindex (eqc eq_nat eq_nat, hashable hashable_nat hashable_nat)
    (eq_nat, hashable_nat)
    (hta_prodWR (eq_nat, hashable_nat) (eq_nat, hashable_nat)
      (eq_nat, hashable_nat) h1 h2);

fun sel_disjoint_witness sel1 mem2 s1 s2 =
  sel1 s1 (fn x => (if mem2 x s2 then SOME x else NONE));

fun hh_disjoint_witness (A1_, A2_) =
  sel_disjoint_witness (hs_sel A2_) (hs_memb (A1_, A2_));

fun brec_initial (A1_, A2_) (B1_, B2_) qi delta =
  let
    val iq = brc_iq (A1_, A2_) delta;
  in
    (brec_iqm (A1_, A2_) B2_ delta,
      (hs_to_fifo A2_ iq,
        (brc_rcm_init (A1_, A2_) (B1_, B2_) delta,
          hh_disjoint_witness (A1_, A2_) iq qi)))
  end;

fun hta_add_rule (A1_, A2_) (B1_, B2_) r h =
  init_hta (hta_Qi h) (ls_ins (eq_ta_rulea A1_ B1_) r (hta_delta h));

fun htai_add_rule x =
  hta_add_rule (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;

fun hta_bwd_reduce (A1_, A2_) (B1_, B2_) h =
  let
    val rqrm = build_rqrm (A1_, A2_) (B1_, B2_) (hta_delta h);
  in
    hta_reduce (A1_, A2_) B1_ h
      (fst (whilea (brc_cond A2_ B2_) (brc_step (A1_, A2_) (B1_, B2_) rqrm)
             (brc_initial (A1_, A2_) (B1_, B2_) (hta_delta h))))
  end;

fun htai_bwd_reduce x =
  hta_bwd_reduce (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;

fun htai_ensure_idx_f x = hta_ensure_idx_f eq_nat (eq_nat, hashable_nat) x;

fun htai_ensure_idx_s x = hta_ensure_idx_s (eq_nat, hashable_nat) eq_nat x;

fun htai_ensure_idx_sf x =
  hta_ensure_idx_sf (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;

fun hta_is_empty_witness (A1_, A2_) (B1_, B2_) h =
  let
    val rqrm = build_rqrm (A1_, A2_) (B1_, B2_) (hta_delta h);
  in
    (case whilea (brec_cond A1_)
            (brec_step (A1_, A2_) (B1_, B2_) rqrm (hta_Qi h))
            (brec_initial (A1_, A2_) (B1_, B2_) (hta_Qi h) (hta_delta h))
      of (q, (_, (_, NONE))) => NONE
      | (q, (_, (_, SOME qa))) => hm_lookup (A1_, A2_) qa q)
  end;

fun htai_is_empty_witness x =
  hta_is_empty_witness (eq_nat, hashable_nat) (eq_nat, hashable_nat) x;

end; (*struct Ta*)
